              dc.b 0,$FF,$FF,0,0,0,2,2,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0
              dc.b 0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0
              dc.b 2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2
 	      dc.b 0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0
              dc.b "SEGA GENESIS    "
              dc.b "(C)Coj 2013JUL22"
              dc.b "Animation test program                          "
              dc.b "Animation test program                          "
              dc.b "GM XXXXXXXX-XX"
              dc.w $DEAD        ;checksum (not used)
              dc.b "J               "
              dc.l 0
              dc.l ROM_End
              dc.l $FF0000
              dc.l $FFFFFF
              dc.b "    "
              dc.b "    "
              dc.b "    "
              dc.b "            "                           
              dc.b "This program contains blast processing. "
              dc.b "JUE             "
                          
	 move.b  $A10001,d0
         andi.b  #$0F,d0
         beq.b   vdp_init
         move.l  #'SEGA',$A14000


vdp_init:
        move.l  #$FFFF,d0           ;loop register
        move.b   #18,d4
	lea	($C00004).l,a0     ;VDP control port
	lea     ($C00000).l,a3     ;VDP data port
	lea	(VDPSetupArray).l,a4

VDP_Loop:
	move.w	(a4)+,(a0)
	dbf	d4,VDP_Loop


        
loop:   
        jsr joypad_read
        
        jsr frame_diag_forward
        move.l d0,d1
        jsr delay
        jsr frame_1       ;up
        move.l d0,d1
        jsr delay
        jsr frame_diag_backward
        move.l d0,d1
        jsr delay
        jsr frame_2       ;right
        jsr joypad_read
        move.l d0,d1
        jsr delay
        jsr frame_diag_forward
        jsr frame_3       ;upsidedown
        move.l d0,d1
        jsr delay
        jsr frame_diag_backward
        jsr frame_4       ;left
        move.l d0,d1
        jsr delay
        jmp loop


joypad_read:

        cmpi #$7e,$A10002    ;up
         beq faster
        cmpi #$7d,$A10002    ;down
         beq slower        
        rts 


faster:
        sub.l #$7FF,d0    ;smaller loop counter
        rts


slower:
        add.l #$7FF,d0    ;larger loop counter
        rts


delay:
        nop
        nop
        nop
        nop
        nop
        dbf d1,delay      ;delay loop
        rts



frame_1:  
        jsr  write_pal1

        lea     (frame1).l,a4
        move.l  #$10,d4
        move.l  #$40000000,$C00004   ;set VRAM write
        move.l  #$8F02,d6
write_vram1:
        move.w	(a4)+,(a3)
        dbf      d4,write_vram1
        rts



frame_2:  
        jsr  write_pal2

        lea     (frame2).l,a4
        move.l  #$10,d4
        move.l  #$40000000,$C00004   ;set VRAM write
        move.l  #$8F02,d6
write_vram2:
        move.w	(a4)+,(a3)
        dbf      d4,write_vram2
        rts
        
        
        
frame_3:  
        jsr  write_pal2

        lea     (frame3).l,a4
        move.l  #$10,d4
        move.l  #$40000000,$C00004   ;set VRAM write
        move.l  #$8F02,d6
write_vram3:
        move.w	(a4)+,(a3)
        dbf      d4,write_vram3
        rts
        
        
frame_4:  
        jsr  write_pal1

        lea     (frame4).l,a4
        move.l  #$10,d4
        move.l  #$40000000,$C00004   ;set VRAM write
        move.l  #$8F02,d6
write_vram4:
        move.w	(a4)+,(a3)
        dbf      d4,write_vram4
        rts                


frame_diag_forward:

        jsr  write_pal1

        lea     (diag2).l,a4
        move.l  #$10,d4
        move.l  #$40000000,$C00004   ;set VRAM write
        move.l  #$8F02,d6
write_vram5:
        move.w	(a4)+,(a3)
        dbf      d4,write_vram5
        rts




frame_diag_backward:
        
        jsr  write_pal1

        lea     (diag1).l,a4
        move.l  #$10,d4
        move.l  #$40000000,$C00004   ;set VRAM write
        move.l  #$8F02,d6
write_vram6:
        move.w	(a4)+,(a3)
        dbf      d4,write_vram6
        rts











write_pal1:

        move.w  #$F,d4
        move.l	#$C0000000,$C00004 ;set VDP to cRAM write
        lea     (palette1_4).l,a4


write_cRAM1:
        move.w	(a4)+,(a3)
	dbf	d4,write_cRAM1
        rts



write_pal2:

        move.w  #$F,d4
        move.l	#$C0000000,$C00004 ;set VDP to cRAM write
        lea     (palette2_3).l,a4


write_cRAM2:
        move.w	(a4)+,(a3)
	dbf	d4,write_cRAM2
        rts









frame1:


        incbin "pb1.bin"
frame2:

        
        incbin "pb2.bin"
frame3:

        
        incbin "pb3.bin"
frame4:

        
        incbin "pb4.bin"

diag1:
        
        incbin "pb1_2.bin"
        

diag2: 
        incbin "pb3_4.bin"



palette1_4:

        incbin "pbpal1_4.bin"


palette2_3:
        
        incbin "pbpal2_3.bin"





VDPSetupArray:
	dc.w $8014		
	dc.w $8174      ; Genesis mode, DMA enabled, VBLANK-INT enabled		
	dc.w $8238	    
	dc.w $833e		
	dc.w $8406		
	dc.w $8578	
	dc.w $8600
	dc.w $8700      ;BG color		
	dc.w $8800
	dc.w $8900
	dc.w $8AFF		
	dc.w $8B00		
	dc.w $8C81		
	dc.w $8D34		
	dc.w $8E00
	dc.w $8F02		
	dc.w $9001		
	dc.w $9100		
	dc.w $9200


        dc.b "Special thanks to Charles MacDonald for VDP documentation cgfm2.emuviews.com"
        dc.b "        Shoutout to everyone at /r/segagenesis"   



ROM_End:



